## dpkg 1.21.22

=== tests/Makefile ===
#
# Dpkg functional testsuite (kind of)
#
# Copyright © 2008-2015 Guillem Jover <guillem@debian.org>
#


-include .pkg-tests.conf

## Feature checks setup ##

include Feature.mk

## Test cases ##

TESTS_MANUAL :=
TESTS_MANUAL += t-deb-lfs
TESTS_MANUAL += t-conffile-prompt

TESTS_FAIL :=
TESTS_FAIL += t-dir-leftover-deadlock
TESTS_FAIL += t-dir-shared-replaces-lost
TESTS_FAIL += t-disappear-depended
TESTS_FAIL += t-conffile-divert-conffile
TESTS_FAIL += t-breaks-multiarch

TESTS_PASS :=
TESTS_PASS += t-db
TESTS_PASS += t-normal
TESTS_PASS += t-field-priority
TESTS_PASS += t-option-dry-run
TESTS_PASS += t-option-recursive
TESTS_PASS += t-control-bogus
TESTS_PASS += t-control-no-arch
TESTS_PASS += t-unpack-symlink
TESTS_PASS += t-unpack-hardlink
TESTS_PASS += t-unpack-divert-hardlink
TESTS_PASS += t-unpack-divert-nowarn
TESTS_PASS += t-unpack-fifo
ifdef DPKG_AS_ROOT
# No permissions for devices
TESTS_PASS += t-unpack-device
endif
TESTS_PASS += t-maintscript-leak
TESTS_PASS += t-filtering
TESTS_PASS += t-depends
TESTS_PASS += t-dir-leftover-parents
TESTS_PASS += t-dir-leftover-conffile
TESTS_PASS += t-disappear
TESTS_PASS += t-disappear-empty
TESTS_PASS += t-provides
TESTS_PASS += t-provides-self
TESTS_PASS += t-provides-arch-implicit
TESTS_PASS += t-provides-arch-qualified
TESTS_PASS += t-breaks
TESTS_PASS += t-breaks-protected
TESTS_PASS += t-breaks-essential
TESTS_PASS += t-conflicts
TESTS_PASS += t-conflict-provide-replace-real
TESTS_PASS += t-conflict-provide-replace-virtual
TESTS_PASS += t-conflict-provide-replace-virtual-multiarch
TESTS_PASS += t-conflict-provide-replace-interface
TESTS_PASS += t-predepends-no-triggers
TESTS_PASS += t-triggers
TESTS_PASS += t-triggers-db
TESTS_PASS += t-triggers-configure
TESTS_PASS += t-triggers-path
TESTS_PASS += t-triggers-depends
TESTS_PASS += t-triggers-depcycle
TESTS_PASS += t-triggers-depfarcycle
TESTS_PASS += t-triggers-selfcycle
TESTS_PASS += t-triggers-cycle
TESTS_PASS += t-triggers-halt
TESTS_PASS += t-file-conflicts
TESTS_PASS += t-file-replaces
TESTS_PASS += t-file-replaces-disappear
TESTS_PASS += t-file-replaces-versioned
TESTS_PASS += t-conffile-normal
TESTS_PASS += t-conffile-obsolete
TESTS_PASS += t-conffile-orphan
TESTS_PASS += t-conffile-forcemiss
TESTS_PASS += t-conffile-forcenew
TESTS_PASS += t-conffile-forceask
TESTS_PASS += t-conffile-root-option
TESTS_PASS += t-conffile-divert-normal
TESTS_PASS += t-conffile-conflict
TESTS_PASS += t-conffile-replaces
TESTS_PASS += t-conffile-replaces-upgrade
TESTS_PASS += t-conffile-replaces-downgrade
TESTS_PASS += t-conffile-replaces-existing
TESTS_PASS += t-conffile-replaces-existing-and-upgrade
TESTS_PASS += t-conffile-replaces-disappear
TESTS_PASS += t-conffile-replaces-diverted
TESTS_PASS += t-conffile-versioned-replaces-downgrade
TESTS_PASS += t-conffile-rename
TESTS_PASS += t-conffile-declarative-removal
TESTS_PASS += t-queue-process-deconf-dupe
TESTS_PASS += t-symlink-dir
TESTS_PASS += t-switch-symlink-abs-to-dir
TESTS_PASS += t-switch-symlink-rel-to-dir
TESTS_PASS += t-switch-dir-to-symlink-abs
TESTS_PASS += t-switch-dir-to-symlink-rel
TESTS_PASS += t-failinst-failrm
TESTS_PASS += t-dir-extension-check
TESTS_PASS += t-multiarch

ifneq (,$(filter test-all,$(DPKG_TESTSUITE_OPTIONS)))
TESTS := $(TESTS_PASS) $(TESTS_FAIL) $(TESTS_MANUAL)
else
TESTS := $(TESTS_PASS)
endif


# By default do nothing
all help::
	@echo "Run 'make test' to run all the tests"
	@echo "Run 'make <test-id>-test' to run a specifict test"
	@echo "Run 'make clean' to remove all intermediary files"
	@echo ""
	@echo "The available tests are: $(TESTS)"

build_targets = $(addsuffix -build,$(TESTS))

build:: $(build_targets)
$(build_targets)::
	$(MAKE) -C $(subst -build,,$@) build

.PHONY: build $(build_targets)


test_targets = $(addsuffix -test,$(TESTS))

test:: $(test_targets)
$(test_targets)::
	$(MAKE) -C $(subst -test,,$@) test

.PHONY: test $(test_targets)


test_clean_targets = $(addsuffix -test-clean,$(TESTS))

test-clean:: $(test_clean_targets)
$(test_clean_targets)::
	$(MAKE) -C $(subst -test-clean,,$@) test-clean

.PHONY: test-clean $(test_clean_targets)


clean_targets = $(addsuffix -clean,$(TESTS))

clean:: $(clean_targets)
$(clean_targets)::
	$(MAKE) -C $(subst -clean,,$@) clean

.PHONY: clean $(clean_targets)

=== tests/t-breaks-protected/Makefile ===
TESTS_DEB := lib-a-0 lib-a-1 pkg-b

include ../Test.mk

DPKG_OPTIONS += --auto-deconfigure

test-case:
	$(DPKG_INSTALL) lib-a-0.deb
	$(DPKG_INSTALL) pkg-b.deb lib-a-1.deb

test-clean:
	$(DPKG_PURGE) pkg-b
	$(DPKG_PURGE) --force-remove-protected lib-a

=== tests/t-disappear-depended/Makefile ===
TESTS_DEB := pkg-normal pkg-depend pkg-disappear

include ../Test.mk

test-case:
	# test disappearing depended package
	$(DPKG_INSTALL) pkg-disappear.deb
	$(DPKG_INSTALL) pkg-depend.deb
	$(DPKG_INSTALL) pkg-normal.deb
	# should not disappear while it's being depended on
	$(call pkg_is_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-depend
	$(DPKG_INSTALL) pkg-normal.deb
	# should have been disappered now
	$(call pkg_is_not_installed,pkg-disappear)

test-clean:
	-$(DPKG_PURGE) pkg-depend
	-$(DPKG_PURGE) pkg-disappear
	$(DPKG_PURGE) pkg-normal

=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13.10~),
 pkgconf | pkg-config,
# Version needed for ITS support.
 gettext (>= 0.19.7),
# Version needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 libmd-dev,
 zlib1g-dev,
 libbz2-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210),
# Needed for the functional test.
 bzip2 <!nocheck>,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0) <!nocheck>,
# Needed for the functional test.
 zstd <!nocheck>,
# Needed for the author release process.
 git <pkg.dpkg.author-release>,
 ca-certificates <pkg.dpkg.author-release>,
 libmodule-build-perl <pkg.dpkg.author-release>,
# Needed for the test suite in author mode.
 fakeroot <pkg.dpkg.author-testing>,
 gnupg <pkg.dpkg.author-testing>,
 cppcheck <pkg.dpkg.author-testing>,
 shellcheck <pkg.dpkg.author-testing>,
 aspell <pkg.dpkg.author-testing>,
 aspell-en <pkg.dpkg.author-testing>,
 codespell <pkg.dpkg.author-testing>,
 i18nspector <pkg.dpkg.author-testing>,
 libtest-minimumversion-perl <pkg.dpkg.author-testing>,
 libtest-perl-critic-perl <pkg.dpkg.author-testing>,
 libtest-pod-coverage-perl <pkg.dpkg.author-testing>,
 libtest-pod-perl <pkg.dpkg.author-testing>,
 libtest-spelling-perl <pkg.dpkg.author-testing>,
 libtest-strict-perl <pkg.dpkg.author-testing>,
 libtest-synopsis-perl <pkg.dpkg.author-testing>,
# Needed for code coverage reports.
 lcov <pkg.dpkg.code-coverage>,
 libdevel-cover-perl <pkg.dpkg.code-coverage>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Version needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libmd-dev,
 zlib1g-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Version needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
# Version needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
 gnupg | sq | sqop | pgpainless-cli,
 gpgv | sq | sqop | pgpainless-cli,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.25.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP feautres, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Version needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
Suggests:
 debian-keyring,
 gnupg | sq | sqop | pgpainless-cli,
 gpgv | sq | sqop | pgpainless-cli,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.25.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP feautres, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildInfo: build information functions
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 libdpkg-perl,
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := \
	-Wall -Wextra \
	-Wno-missing-field-initializers \
	-Wno-nonnull-compare \
	-Wno-unused-parameter \
	# EOL

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = $(WFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(WFLAGS)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS)" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/build-aux/run-script scripts/dpkg-buildflags.pl

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	TESTSUITEFLAGS += --verbose
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  TESTSUITEFLAGS += -j$(NUMJOBS)
endif

testflags = TESTSUITEFLAGS=$(TESTSUITEFLAGS) TEST_PARALLEL=$(NUMJOBS)

D := $(CURDIR)/debian/tmp

%:
	dh $@ --builddirectory=build-tree

override_dh_auto_configure:
	dh_auto_configure -- \
		$(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--sbindir=/sbin \
		--libexecdir=\$${exec_prefix}/lib \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--with-libz \
		--with-liblzma \
		--with-libzstd \
		--with-libbz2 \
		# EOL

execute_after_dh_auto_install:
	# Special-case the lintian profile, as dh cannot rename on install.
	mkdir -p $(D)/usr/share/lintian/profiles/dpkg
	cp debian/dpkg.lintian-profile \
	   $(D)/usr/share/lintian/profiles/dpkg/main.profile

override_dh_auto_test:
	dh_auto_test -- $(testflags)

override_dh_installsystemd:
	dh_installsystemd -a --name=dpkg-db-backup

execute_after_dh_installlogrotate:
	dh_installlogrotate --name=alternatives

override_dh_installdocs:
	dh_installdocs -Ndpkg-dev
	dh_installdocs -pdpkg-dev --doc-main-package=dpkg

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

override_dh_bugfiles:
	dh_bugfiles -A

override_dh_compress:
	dh_compress -Xspec/

=== debian/tests/control ===
Tests: test-not-root
Depends: build-essential, autoconf, pkg-config, libmd-dev, file
Restrictions: superficial skippable

Tests: test-root
Depends: build-essential, autoconf, pkg-config, libmd-dev, file
Restrictions: superficial needs-root breaks-testbed

Tests: test-func
Depends: @, eatmydata
Restrictions: allow-stderr

Tests: test-func-root
Depends: @, eatmydata
Restrictions: allow-stderr needs-root breaks-testbed

## dpkg 1.21.22pureos2~cri2

=== debian/changelog ===
dpkg (1.21.22pureos2~cri2) crimson; urgency=medium

  * Add gbp.conf to EXTRA_DIST

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 01 Nov 2024 11:22:30 +0100

dpkg (1.21.22pureos2~cri1.1) crimson; urgency=medium

  * Reupload after `make dist`.

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 01 Nov 2024 11:09:05 +0100

dpkg (1.21.22pureos2~cri1) crimson; urgency=medium

  [ João Azevedo ]
  * Silence dpkg usr-merge warnings on PureOS. (Closes: #2)

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Wed, 30 Oct 2024 04:07:18 +0100

dpkg (1.21.22pureos1) crimson; urgency=medium

  * Upload to crimson
  * Remaining relevant changes: Dpkg/Vendor/PureOS.pm

 -- Guido Günther <agx@sigxcpu.org>  Tue, 13 Jun 2023 12:34:33 +0200

dpkg (1.21.21pureos1) crimson; urgency=medium

  * Upload to crimson

 -- Guido Günther <agx@sigxcpu.org>  Fri, 21 Apr 2023 12:40:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: dpkg
 Section: admin
 Priority: required
-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
+Maintainer: PureOS Maintainers <pureos-project@lists.puri.sm>
+XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
 Uploaders: Guillem Jover <guillem@debian.org>
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git

## dpkg 1.21.22ubuntu1

=== debian/changelog ===
dpkg (1.21.22ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'nocheck' in build options by default
      on Ubuntu/riscv64.  Overridable in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl:
      Set 'nocheck' for riscv64 using a new 'update-buildopts' hook and make
      it effective with old style debhelper, too.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Fix dpkg handling of --path-exclude for read-only paths (LP: #2003789).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 May 2023 17:55:17 +0200

## dpkg 1.21.22+rpi1

=== debian/changelog ===
dpkg (1.21.22+rpi1) bookworm-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )

  [changes introduce in 1.21.17+rpi1 by Peter Michael Green]
  * disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Fri, 02 Jun 2023 07:43:27 +0000

=== debian/rules ===
--- 
+++ 
@@ -63,7 +63,7 @@
 	   $(D)/usr/share/lintian/profiles/dpkg/main.profile
 
 override_dh_auto_test:
-	dh_auto_test -- $(testflags)
+	#dh_auto_test -- $(testflags)
 
 override_dh_installsystemd:
 	dh_installsystemd -a --name=dpkg-db-backup

## dpkg 1.22.0

=== tests/Makefile ===
--- 
+++ 
@@ -20,8 +20,6 @@
 TESTS_FAIL :=
 TESTS_FAIL += t-dir-leftover-deadlock
 TESTS_FAIL += t-dir-shared-replaces-lost
-TESTS_FAIL += t-disappear-depended
-TESTS_FAIL += t-conffile-divert-conffile
 TESTS_FAIL += t-breaks-multiarch
 
 TESTS_PASS :=
@@ -36,6 +34,7 @@
 TESTS_PASS += t-unpack-hardlink
 TESTS_PASS += t-unpack-divert-hardlink
 TESTS_PASS += t-unpack-divert-nowarn
+TESTS_PASS += t-unpack-divert-overwrite
 TESTS_PASS += t-unpack-fifo
 ifdef DPKG_AS_ROOT
 # No permissions for devices
@@ -47,6 +46,9 @@
 TESTS_PASS += t-dir-leftover-parents
 TESTS_PASS += t-dir-leftover-conffile
 TESTS_PASS += t-disappear
+TESTS_PASS += t-disappear-depended
+TESTS_PASS += t-disappear-diverted
+TESTS_PASS += t-disappear-diverted-other
 TESTS_PASS += t-disappear-empty
 TESTS_PASS += t-provides
 TESTS_PASS += t-provides-self
@@ -56,6 +58,7 @@
 TESTS_PASS += t-breaks-protected
 TESTS_PASS += t-breaks-essential
 TESTS_PASS += t-conflicts
+TESTS_PASS += t-conflicts-replaces
 TESTS_PASS += t-conflict-provide-replace-real
 TESTS_PASS += t-conflict-provide-replace-virtual
 TESTS_PASS += t-conflict-provide-replace-virtual-multiarch
@@ -83,6 +86,7 @@
 TESTS_PASS += t-conffile-forceask
 TESTS_PASS += t-conffile-root-option
 TESTS_PASS += t-conffile-divert-normal
+TESTS_PASS += t-conffile-divert-conffile
 TESTS_PASS += t-conffile-conflict
 TESTS_PASS += t-conffile-replaces
 TESTS_PASS += t-conffile-replaces-upgrade

=== tests/t-conffile-conflict/Makefile ===
TESTS_DEB := pkg-conff-a pkg-conff-b pkg-conff-c

include ../Test.mk

TEST_CASES += test-conflict-installed-implicit
TEST_CASES += test-conflict-removed-implicit
TEST_CASES += test-conflict-removed-explicit

test-case: $(TEST_CASES)

test-conflict-installed-implicit:
	# test if packages fail on install due to conflicting conffile
	$(DPKG_INSTALL) pkg-conff-a.deb
	! $(DPKG_INSTALL) pkg-conff-b.deb
	-$(DPKG_PURGE) pkg-conff-b
	$(DPKG_PURGE) pkg-conff-a

test-conflict-removed-implicit:
	# test that conffile of removed package can be taken over
	$(DPKG_INSTALL) pkg-conff-a.deb
	$(DPKG_REMOVE) pkg-conff-a
	$(DPKG_INSTALL) pkg-conff-b.deb
	# Verify the new conffile has been installed
	grep -q pkg-conff-b "$(DPKG_INSTDIR)/test-conffile"
	# Verify it's kept after purge of old package
	$(DPKG_PURGE) pkg-conff-a
	test -e "$(DPKG_INSTDIR)/test-conffile"
	$(DPKG_PURGE) pkg-conff-b

test-conflict-removed-explicit:
	# test that conffile of removed package can be taken over even if
	# the new package is conflicting with the old one
	$(DPKG_INSTALL) pkg-conff-a.deb
	$(DPKG_REMOVE) pkg-conff-a
	$(DPKG_INSTALL) pkg-conff-c.deb
	# Verify the new conffile has been installed
	grep -q pkg-conff-c "$(DPKG_INSTDIR)/test-conffile"
	# Verify it's kept after purge of old package
	$(DPKG_PURGE) pkg-conff-a
	test -e "$(DPKG_INSTDIR)/test-conffile"
	$(DPKG_PURGE) pkg-conff-c

test-clean:
	-$(DPKG_PURGE) pkg-conff-a pkg-conff-b pkg-conff-c

=== tests/t-disappear-diverted-other/Makefile ===
TESTS_DEB := pkg-divert pkg-diverted pkg-replaces

include ../Test.mk

test-case:
	# Test disappearing diverted package with a not contended pathname.
	$(DPKG_INSTALL) pkg-divert.deb
	$(DPKG_INSTALL) pkg-diverted.deb
	$(DPKG_INSTALL) pkg-replaces.deb
	# Should disappear because there is no contended pathname.
	$(call pkg_is_not_installed,pkg-divert)
	$(DPKG_PURGE) pkg-divert
	$(DPKG_PURGE) pkg-diverted
	$(DPKG_PURGE) pkg-replaces
	:
	# Test disappearing diverted package with a not contended pathname.
	$(DPKG_INSTALL) pkg-divert.deb
	$(DPKG_INSTALL) pkg-replaces.deb
	# Should disappear because there is no contended pathname.
	$(call pkg_is_not_installed,pkg-divert)
	$(DPKG_PURGE) pkg-divert
	$(DPKG_PURGE) pkg-replaces

test-clean:
	$(DPKG_PURGE) pkg-divert
	$(DPKG_PURGE) pkg-diverted
	$(DPKG_PURGE) pkg-replaces

=== tests/t-disappear-diverted/Makefile ===
TESTS_DEB := pkg-normal pkg-divert pkg-disappear

include ../Test.mk

test-case:
	# Test not disappearing diverted package.
	$(DPKG_INSTALL) pkg-disappear.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_INSTALL) pkg-divert.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	# Should not disappear while it's being diverted.
	$(call pkg_is_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-divert
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_PURGE) pkg-disappear
	:
	# Test disappearing package not being diverted.
	$(DPKG_INSTALL) pkg-disappear.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_INSTALL) pkg-normal.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	# Should have been disappered now.
	$(call pkg_is_not_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_PURGE) pkg-disappear
	:
	# Test disappearing package diverted but replaced by a 3rd package.
	$(DPKG_INSTALL) pkg-disappear.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_INSTALL) pkg-divert.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_INSTALL) pkg-normal.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	# Should have been disappered now, as it is diverted by a 3rd package.
	$(call pkg_is_not_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-normal
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_PURGE) pkg-divert
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_PURGE) pkg-disappear

test-clean:
	$(DPKG_PURGE) pkg-divert
	$(DPKG_PURGE) pkg-disappear
	$(DPKG_PURGE) pkg-normal

=== tests/t-unpack-divert-overwrite/Makefile ===
TESTS_DEB := pkg-files pkg-divert pkg-replaces

include ../Test.mk

test-case:
	# Test failure to install a package overwritting a diversion (order 1).
	$(DPKG_INSTALL) pkg-divert.deb
	test -e $(DPKG_INSTDIR)/test-file
	! test -e $(DPKG_INSTDIR)/test-other
	$(DPKG_INSTALL) pkg-files.deb
	test -e $(DPKG_INSTDIR)/test-file
	test -e $(DPKG_INSTDIR)/test-other
	! $(DPKG_INSTALL) pkg-replaces.deb
	test -e $(DPKG_INSTDIR)/test-file
	test -e $(DPKG_INSTDIR)/test-other
	$(call pkg_is_installed,pkg-divert)
	$(call pkg_is_not_installed,pkg-replaces)
	$(DPKG_PURGE) pkg-files
	$(DPKG_PURGE) pkg-divert
	$(DPKG_PURGE) pkg-replaces
	! test -e $(DPKG_INSTDIR)/test-file
	! test -e $(DPKG_INSTDIR)/test-other
	:
	# Test failure to install a package overwritting a diversion (order 2).
	$(DPKG_INSTALL) pkg-files.deb
	test -e $(DPKG_INSTDIR)/test-file
	! test -e $(DPKG_INSTDIR)/test-other
	$(DPKG_INSTALL) pkg-divert.deb
	test -e $(DPKG_INSTDIR)/test-file
	test -e $(DPKG_INSTDIR)/test-other
	! $(DPKG_INSTALL) pkg-replaces.deb
	test -e $(DPKG_INSTDIR)/test-file
	test -e $(DPKG_INSTDIR)/test-other
	$(call pkg_is_installed,pkg-divert)
	$(call pkg_is_not_installed,pkg-replaces)
	$(DPKG_PURGE) pkg-files
	$(DPKG_PURGE) pkg-divert
	$(DPKG_PURGE) pkg-replaces
	! test -e $(DPKG_INSTDIR)/test-file
	! test -e $(DPKG_INSTDIR)/test-other
	:
	# Test success to install a package overwritting a diversion (forced).
	$(DPKG_INSTALL) pkg-files.deb
	test -e $(DPKG_INSTDIR)/test-file
	! test -e $(DPKG_INSTDIR)/test-other
	$(DPKG_INSTALL) pkg-divert.deb
	test -e $(DPKG_INSTDIR)/test-file
	test -e $(DPKG_INSTDIR)/test-other
	$(DPKG_INSTALL) --force-overwrite-diverted pkg-replaces.deb
	test -e $(DPKG_INSTDIR)/test-file
	test -e $(DPKG_INSTDIR)/test-other
	$(call pkg_is_installed,pkg-divert)
	$(call pkg_is_installed,pkg-replaces)
	$(DPKG_PURGE) pkg-replaces
	$(DPKG_PURGE) pkg-divert
	$(DPKG_PURGE) pkg-files
	! test -e $(DPKG_INSTDIR)/test-file
	! test -e $(DPKG_INSTDIR)/test-other

	# XXX: In the force case, if we purge pkg-replaces last, then it
	# will leave behind on the fsys an unowned file.

test-clean:
	$(DPKG_PURGE) pkg-files pkg-divert pkg-replaces

=== debian/changelog ===
dpkg (1.22.0) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg: Do not reset the line number for each --command-fd parsed command.
  * dselect: Add non-free-firmware archive area support.
  * dselect: Relicense ftp method from GPL-2 to GPL-2+.
  * dpkg-deb: Do not print trailing spaces in --info output.
  * dpkg: Clarify that commands can take package-name or --pending in error
    message. Closes: #1034466
  * Remove avr32, m32r and tilegx obsolete architectures.
    See Linux commit 26202873bb51fafdaa51be3e8de7aab9beb49f70 (avr32).
    See Linux commit 553b085c2075f6a4a2591108554f830fa61e881f (m32r).
    See Linux commit bb9d812643d8a121df7d614a2b9c60193a92deb0 (tile).
  * dpkg-db-keeper: Add helper script to assist with tracking database changes.
  * dpkg-buildpackage: Add support for new preinit hook. Closes: #1023753
  * dselect: Remove handling of .GZ, .Z and .z compressed Package files.
  * dselect: Fix stdout+stderr discarding redirection in ftp method.
    Prompted by shellcheck.
  * dpkg-buildpackage: Fix build hook action substitution string handling.
  * dpkg-buildpackage: Set the hook options in an environment variable.
    Closes: #902856
  * dpkg-buildpackage: Set DPKG_BUILDPACKAGE_HOOK_NAME envvar for hooks.
  * dpkg-buildpackage: Handle missing information for hook substitutions.
  * dpkg-deb: Fix short lived memory leak after fork().
  * Switch from pkg-config to pkgconf.
  * dpkg: Handle non-existent .dpkg-tmp files on read-only filesystems.
    Closes: #1030149
  * dpkg-buildpackage: Fix R³ namespace check to only refuse unknown dpkg
    keywords. Closes: #1036865
  * dpkg-buildapi: New tool to fetch the dpkg-build-api level.
  * dpkg-shlibdeps: On dpkg-build-api >= 1 require -l instead of
    LD_LIBRARY_PATH.
  * dpkg-buildpackage: On dpkg-build-api >= 1 default R³ to no.
  * dpkg-buildpackage: On dpkg-build-api >= 1 avoid build target heuristics.
  * Mark dpkg-build-api level 1 as stable.
  * Architecture support:
    - Restore "arch: Add support for loong64 CPU". Closes: #1028654
  * Perl modules:
    - Dpkg::OpenPGP::ErrorCodes: Add new OPENPGP_CMD_CANNOT_SIGN error code.
    - Dpkg::OpenPGP::Backend::GnuPG: On signing failure use
      OPENPGP_CMD_CANNOT_SIGN. Closes: #1030271
    - Dpkg::Shlibs::Objdump::Object: Split from Dpkg::Shlibs::Objdump.
    - Dpkg::Control::HashCore::Tie: Split from Dpkg::Control::HashCore.
    - Dpkg::Vars: Fold into Dpkg::Package.
    - Dpkg::Package: Rename source_package symbols to source_name.
    - Dpkg::Changelog::Parse: Fix indentation of copyright and license notice.
    - Dpkg::Version: Update POD for removed semantic_change::overload::bool
      warning.
    - Dpkg::Gettext: Relicense from BSD-2 to GPL-2+.
    - Dpkg::Source::Archive: Fix file normalization for relative pathnames.
    - Dpkg::Source::Archive: Reflow regex match in _add_entry().
    - Dpkg::Control::FieldsCore: Deprecate implicit field_transfer_single()
      argument.
    - Dselect::Method::Ftp: Rename from Dselect::Ftp.
    - Dselect::Method::Ftp: Modify config and site subs towards method
      independence.
    - Dselect::Method: Move to be generic functions from Dselect::Ftp.
    - Dselect::Method::Ftp: Update package name.
    - Dpkg::Vendor::Debian: Add time64 feature in the future area.
      Based on a patch by Helge Deller <deller@gmx.de>. Closes: #1030159
    - Dpkg::Control::HashCore::Tie: Rename $last to $prev.
    - Dpkg::Substvars: Handle exponential expansion gracefully.
    - Dpkg::Shlibs::Objdump: Remove unsupported ELF machine types.
    - Dpkg::Shlibs::Objdump: Add ELF machine types for all supported arches.
    - Dpkg::Shlibs::Objdump: Add RISC-V ELF ABI tracking.
    - Dpkg::Shlibs::Objdump: Add OR1K ELF ABI tracking.
    - Dpkg::Shlibs::Objdump: Switch get_format() to return a colon-separated
      string.
    - Dpkg::Shlibs::Objdump: Add back the ARM ABI mismatch mask but commented
      out. See #853793.
    - Dpkg::Source::Quilt: Switch get_db_file() to be based off get_db_dir().
    - Dpkg::Vendor::Debian: Mark PIE as builtin on hurd-amd64.
    - Dpkg::Vendor::Debian: Only use ABI bits to suppress LFS or time64
      features.
    - Dpkg::Vendor::Debian: Only enable LFS when time64 is enabled for glibc.
    - Dpkg::Vendor::Debian: Invert time64 suppression list logic.
    - Dpkg::Vendor::Debian: Ignore musl libc systems for time64 suppression.
    - Dpkg::Vendor::Debian: Add fallback values for ABI attributes.
    - Dpkg::Source::Package::V2: Mark single-debian-patch as not needing
      forwarding. Closes: #1038121
    - Dpkg::Vendor::Debian: Sync builtin pie arches with gcc-13.
    - Dpkg::Vendor::Debian: Move time64 buildflags feature from future to abi.
      Suggested by Steve Langasek <vorlon@debian.org>.
    - Dpkg::Vendor::Debian: Move lfs from future to abi area and create an
      alias. Suggested by Steve Langasek <vorlon@debian.org>.
    - Dpkg::Vendor::Debian: Move builtin default setup before
      init_build_features().
    - Dpkg::Vendor::Debian: Handle abi feature flags as builtin.
    - Dpkg::Vendor::Debian: Add support for new hardening branch feature.
      Closes: #1021292
    - Dpkg::Vendor::Debian: Add support for new stackclash hardening feature.
      Closes: #918914
    - Dpkg::Source::Quilt: Switch get_patch_file() to be based off
      get_patch_dir().
    - Dpkg::BuildAPI: New module.
  * Make fragments:
    - Add new buildapi.mk support.
    - On dpkg-build-api >= 1 default to dpkg_vendor_derives_from_v1.
    - On dpkg-build-api >= 1 include buildtools.mk in default.mk.
  * Documentation:
    - man: Add notes about reproducibility properties for path fixing build
      features. Prompted by Sven Joachim <svenjoac@gmx.de>.
    - man: Itemize remaining lists.
    - man: Unify admonition markup and formatting.
    - man: Move shell redirection operator close to the redirected file.
    - man: Add versions where build flag features were added.
    - doc: Update triggers spec.


=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: dpkg
 Section: admin
 Priority: required
-Maintainer: PureOS Maintainers <pureos-project@lists.puri.sm>
-XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
+Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
 Uploaders: Guillem Jover <guillem@debian.org>
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
@@ -12,7 +11,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  debhelper (>= 13.10~),
- pkgconf | pkg-config,
+ pkgconf,
 # Version needed for ITS support.
  gettext (>= 0.19.7),
 # Version needed for --porefs defaults, conditional addenda and mode=eof.
@@ -139,6 +138,9 @@
 # Uses required SOP feautres, w/o requiring a hard dependency on pgpainless.
  pgpainless-cli (<< 1.3.13~),
  libsop-java-java (<< 4.0.7~),
+Provides:
+ dpkg-build-api (= 0),
+ dpkg-build-api (= 1),
 Description: Debian package development tools
  This package provides the development tools (including dpkg-source)
  required to unpack, build and upload Debian source packages.

=== debian/rules ===
--- 
+++ 
@@ -63,10 +63,10 @@
 	   $(D)/usr/share/lintian/profiles/dpkg/main.profile
 
 override_dh_auto_test:
-	#dh_auto_test -- $(testflags)
+	dh_auto_test -- $(testflags)
 
 override_dh_installsystemd:
-	dh_installsystemd -a --name=dpkg-db-backup
+	dh_installsystemd -a --name=dpkg-db-backup --no-start
 
 execute_after_dh_installlogrotate:
 	dh_installlogrotate --name=alternatives

## dpkg 1.22.0ubuntu1

=== debian/changelog ===
dpkg (1.22.0ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'nocheck' in build options by default
      on Ubuntu/riscv64.  Overridable in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl:
      Set 'nocheck' for riscv64 using a new 'update-buildopts' hook and make
      it effective with old style debhelper, too.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 31 Aug 2023 22:46:40 +0200

=== debian/rules ===
--- 
+++ 
@@ -83,3 +83,10 @@
 
 override_dh_compress:
 	dh_compress -Xspec/
+
+override_dh_builddeb:
+	# Make debootstrap life easier on non-Debian based systems by
+	# compressing dpkg.deb with xz instead of zstd.
+	dh_builddeb -pdpkg -- -Zxz
+	dh_builddeb -a -Ndpkg
+	dh_builddeb

## dpkg 1.22.0ubuntu1.1

=== debian/changelog ===
dpkg (1.22.0ubuntu1.1) mantic; urgency=medium

  [ Luca Boccassi ]
  * Fix dpkg-buildpackage ignoring DEB_BUILD_PROFILES (LP: #2054741)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 23 Feb 2024 15:56:43 +0100

=== debian/control ===
--- 
+++ 
@@ -118,6 +118,7 @@
  patch (>= 2.7),
  make,
  binutils,
+ lto-disabled-list,
 Recommends:
  build-essential,
  gcc | c-compiler,

## dpkg 1.22.0+parrot1

=== tests/t-disappear-depended/Makefile ===
TESTS_DEB := pkg-normal pkg-depend pkg-disappear

include ../Test.mk

test-case:
	# Test disappearing depended package.
	$(DPKG_INSTALL) pkg-disappear.deb
	$(DPKG_INSTALL) pkg-depend.deb
	$(DPKG_INSTALL) pkg-normal.deb
	# Should not disappear while it is being depended on.
	$(call pkg_is_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-depend
	$(DPKG_PURGE) pkg-normal
	:
	# Should disappear now that it is not being depended on.
	$(DPKG_INSTALL) pkg-disappear.deb
	$(DPKG_INSTALL) pkg-normal.deb
	# Should have been disappered now.
	$(call pkg_is_not_installed,pkg-disappear)

test-clean:
	-$(DPKG_PURGE) pkg-depend
	-$(DPKG_PURGE) pkg-disappear
	$(DPKG_PURGE) pkg-normal

=== debian/changelog ===
dpkg (1.22.0+parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 00:45:47 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: dpkg
 Section: admin
 Priority: required
-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
-Uploaders: Guillem Jover <guillem@debian.org>
+XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
+Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
 Homepage: https://wiki.debian.org/Teams/Dpkg
-Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
-Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
+XS-Debian-Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
+XS-Debian-Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Build-Depends:
@@ -118,7 +119,6 @@
  patch (>= 2.7),
  make,
  binutils,
- lto-disabled-list,
 Recommends:
  build-essential,
  gcc | c-compiler,
